Contabilidad/Contabilidad.Site/Models/Warehouse/StockViewModel.cs
using System.ComponentModel.DataAnnotations;

namespace Contabilidad.Site.Models.Warehouse
{
    public class StockViewModel
    {
        [Display(Name = nameof(Product), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Stock))]
        public string Product { get; set; }

        [Display(Name = nameof(Quantity), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Stock))]
        public int Quantity { get; set; }

        [Display(Name = nameof(MeasurementUnit), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Stock))]
        public string MeasurementUnit { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Models/Warehouse/WarehouseCreateViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Contabilidad.Site.Models.Warehouse
{
    public class WarehouseCreateViewModel
    {
        [Display(Name = nameof(Id), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        public int Id { get; set; }

        [Display(Name = nameof(Description), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        public string Description { get; set; }

        [Display(Name = nameof(Code), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public string Code { get; set; }

        [Display(Name = nameof(IsActive), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public bool IsActive { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Models/Warehouse/WarehouseDetailsViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Contabilidad.Site.Models.Warehouse
{
    public class WarehouseDetailsViewModel
    {
        [Display(Name = nameof(Id), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        public int Id { get; set; }

        [Display(Name = nameof(Description), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        public string Description { get; set; }

        [Display(Name = nameof(Code), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public string Code { get; set; }

        [Display(Name = nameof(IsActive), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public bool IsActive { get; set; }

        [Display(Name = nameof(Stocks), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        public IEnumerable <StockViewModel> Stocks { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Models/Warehouse/WarehouseEditViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Contabilidad.Site.Models.Warehouse
{
    public class WarehouseEditViewModel
    {
        [Display(Name = nameof(Id), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        public int Id { get; set; }

        [Display(Name = nameof(Description), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        public string Description { get; set; }

        [Display(Name = nameof(Code), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public string Code { get; set; }

        [Display(Name = nameof(IsActive), ResourceType = typeof(Resources.Models.Accounting.Warehouse.Warehouse))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public bool IsActive { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Controllers/WarehouseController.cs
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Contabilidad.Core.Warehouse;
using Contabilidad.Site.Models.Warehouse;
using Microsoft.AspNetCore.Mvc;

namespace Contabilidad.Site.Controllers
{
    public class WarehouseController : Controller
    {
        private readonly IWarehouseManager warehouseManager;

        public WarehouseController(
            IWarehouseManager warehouseManager)
        {
            this.warehouseManager = warehouseManager;
        }
        public async Task<IActionResult> Index(string errorMessage)
        {
            if (!string.IsNullOrEmpty(errorMessage))
            {
                this.ModelState.AddModelError(string.Empty, errorMessage);
            }

            var warehouses = await this.warehouseManager.GetAllAsync();
            var model = warehouses.OrderBy(b => b.Code).Select(b => new WarehouseListViewModel
            {
                Id = b.Id,
                Description = b.Description,
                Code = b.Code,
                IsActive = b.IsActive,
            });

            return View(model);
        }
        public async Task<IActionResult> Create()
        {
            return this.View();
        }

        public async Task<IActionResult> Delete(int? id)
        {
            if (!id.HasValue)
            {
                return this.BadRequest();
            }

            var warehouse = await this.warehouseManager.GetByIdAsync(id.Value);

            if (warehouse == null)
            {
                return this.BadRequest();
            }

            var result = await this.warehouseManager.DeleteAsync(id.Value);
            var errorMessages = new StringBuilder();
            if (!result.Succeeded)
            {
                foreach (var validations in result.ValidationMessages)
                {
                    foreach (var item in validations.Value)
                    {
                        errorMessages.Append(item);
                    }
                }

                return this.RedirectToAction(nameof(Index), new { errorMessage = errorMessages });
            }

            return this.RedirectToAction(nameof(Index));
        }

        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return this.BadRequest();
            }

            var warehouse = await this.warehouseManager.GetByIdAsync(id.Value);

            if (warehouse == null)
            {
                return this.BadRequest();
            }

            return this.View(new WarehouseEditViewModel
            {
                Id = warehouse.Id,
                Description = warehouse.Description,
                Code = warehouse.Code,
                IsActive = warehouse.IsActive,
            });
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(WarehouseEditViewModel warehouseEditViewModel)
        {
            if (!this.ModelState.IsValid)
            {
                return this.View(warehouseEditViewModel);
            }

            var warehouse = await this.warehouseManager.GetByIdAsync(warehouseEditViewModel.Id);

            if (warehouse == null)
            {
                return this.BadRequest();
            }

            warehouse.Code = warehouseEditViewModel.Code;
            warehouse.Description = warehouseEditViewModel.Description;
            warehouse.IsActive = warehouseEditViewModel.IsActive;

            var result = await this.warehouseManager.EditAsync(warehouse);

            if (!result.Succeeded)
            {
                foreach (var validations in result.ValidationMessages)
                {
                    foreach (var item in validations.Value)
                    {
                        this.ModelState.AddModelError(string.Empty, item);
                    }
                }

                return this.View(warehouseEditViewModel);
            }

            return this.RedirectToAction(nameof(Index));
        }
        public async Task<IActionResult> Details(int? idWarehouse)
        {
            if (idWarehouse == null)
            {
                return this.BadRequest();
            }

            var warehouse = await this.warehouseManager.GetByIdAsync(idWarehouse.Value);

            if (warehouse == null)
            {
                return this.BadRequest();
            }
            return this.View(new WarehouseDetailsViewModel
            {
                Id = warehouse.Id,
                Code = warehouse.Code,
                Description = warehouse.Description,
                IsActive = warehouse.IsActive,
                Stocks = warehouse.Details.Where(d => d.Quantity > 0).Select(d => new StockViewModel
                {
                    Product = d.Product.Name,
                    Quantity = d.Quantity,
                    MeasurementUnit = d.Product.MeasurementUnit.MeasurementName,
                }),
            });
        }



        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(WarehouseCreateViewModel warehouseCreateViewModel)
        {
            if (!this.ModelState.IsValid)
            {
                return this.View(warehouseCreateViewModel);
            }

            var result = await this.warehouseManager.CreateAsync(new Database.Models.Accounting.Warehouse
            {
                Code = warehouseCreateViewModel.Code,
                Description = warehouseCreateViewModel.Description,
                IsActive = warehouseCreateViewModel.IsActive,
                Location = new Database.Models.Accounting.Location
                {
                    Accuracy = 0,
                    Altitude = 0,
                    AltitudeAccuracy = 0,
                    Heading = 0,
                    Latitude = 0,
                    Longitude = 0,
                },
            });

            if (!result.Succeeded)
            {
                foreach (var validations in result.ValidationMessages)
                {
                    foreach (var item in validations.Value)
                    {
                        this.ModelState.AddModelError(string.Empty, item);
                    }
                }

                return this.View(warehouseCreateViewModel);
            }

            return this.RedirectToAction(nameof(Index));
        }
    }
}

Contabilidad/Contabilidad.Site/Controllers/WarehouseMovementController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Contabilidad.Core.AssignPurchaseToWarehouse;
using Contabilidad.Core.Product;
using Contabilidad.Core.Warehouse;
using Contabilidad.Database.Models.Accounting;
using Contabilidad.Database.Repositories;
using Contabilidad.Site.Models;
using Contabilidad.Site.Models.WarehouseMovement;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace Contabilidad.Site.Controllers
{
    public class WarehouseMovementController : Controller
    {
        private readonly IWarehouseManager warehouseManager;
        private readonly IWarehouseMovementManager warehouseMovementManager;
        private readonly IRepository<Warehouse> warehouseRepository;
        private readonly IProductManager productManager;

        public WarehouseMovementController(
            IWarehouseManager warehouseManager,
            IWarehouseMovementManager warehouseMovementManager,
            IRepository<Warehouse> warehouseRepository,
            IProductManager productManager)
        {
            this.warehouseManager = warehouseManager;
            this.warehouseMovementManager = warehouseMovementManager;
            this.warehouseRepository = warehouseRepository;
            this.productManager = productManager;
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> MovementToWareohuses(WarehouseMovementCreateViewModel warehouseMovementCreateViewModel)
        {
            warehouseMovementCreateViewModel.Details = warehouseMovementCreateViewModel.Details.Where(d => d.IsDeleted == null || !d.IsDeleted.Value);

            if (!this.ModelState.IsValid)
            {
                warehouseMovementCreateViewModel.Index = warehouseMovementCreateViewModel.Details.Count();
                return this.View(warehouseMovementCreateViewModel);
            }


            if (warehouseMovementCreateViewModel.Details == null)
            {
                return this.RedirectToAction("Details", "Warehouse", new { idWarehouse = warehouseMovementCreateViewModel.IdWarehouseOrigin });
            }

            var result = await this.warehouseMovementManager.CreateAsync(new Database.Models.Accounting.WarehouseMovement
            {
                IdWarehouseOrigin = warehouseMovementCreateViewModel.IdWarehouseOrigin,
                //IdUsser = CODE HERE   CODE HERE   CODE HERE   CODE HERE
                MovementDate = DateTime.Now,
                Details = warehouseMovementCreateViewModel.Details.Select(d => new Database.Models.Accounting.WarehouseMovementDetail
                {
                    IdProduct = d.IdProduct.Value,
                    IdWarehouseDestination = d.IdWarehouseDestination,
                    Quantity = d.Quantity,
                }).ToList(),
            });


            if (!result.Succeeded)
            {
                foreach (var validations in result.ValidationMessages)
                {
                    foreach (var item in validations.Value)
                    {
                        this.ModelState.AddModelError(string.Empty, item);
                    }
                }

                warehouseMovementCreateViewModel.Index = warehouseMovementCreateViewModel.Details.Count();
                return this.View(warehouseMovementCreateViewModel);
            }
            return this.RedirectToAction("Details", "Warehouse", new { idWarehouse = warehouseMovementCreateViewModel.IdWarehouseOrigin });
        }

        public async Task<ActionResult> AddDetail(int? index, int? idWarehouseOrigin)
        {
            if (idWarehouseOrigin == null || index == null)
            {
                return this.BadRequest();
            }

            return PartialView("MovementToWareohusesDetailCreate", new WarehouseMovementDetailCreateViewModel
            {
                Index = index.Value,
                IsDeleted = false,
                Products = await this.GetProducts(idWarehouseOrigin.Value),
                WarehousesDestination = await this.GetWarehouses(idWarehouseOrigin.Value),
            });
        }

        public async Task<IActionResult> MovementToWareohuses(int? idWarehouse)
        {
            if (idWarehouse == null)
            {
                return this.BadRequest();
            }

            var warehouse = await this.warehouseManager.GetByIdAsync(idWarehouse.Value);

            if (warehouse == null)
            {
                return this.BadRequest();
            }

            var model = new WarehouseMovementCreateViewModel()
            {
                Code = warehouse.Code,
                IdWarehouseOrigin = idWarehouse.Value,
                Index = 0,
                Details = new List<WarehouseMovementDetailCreateViewModel>(),
            };

            return this.View(model);
        }

        private async Task<IEnumerable<SelectListViewModel>> GetWarehouses(int? idWarehouse)
        {
            if (idWarehouse == null)
            {
                return new List<SelectListViewModel>();
            }

            return new List<SelectListViewModel>() {
                new SelectListViewModel
                {
                    Value = Resources.Models.Accounting.Warehouse.WarehouseMovementDetail.WarehouseDestinationSelected
                }
            }
            .Union(await this.warehouseRepository.Filter(w => w.Id != idWarehouse.Value).Where(w => w.IsActive).Select(b => new SelectListViewModel
            {
                Id = b.Id,
                Value = b.Code,
            }).ToListAsync());
        }


        private async Task<IEnumerable<SelectListViewModel>> GetProducts(int? idWarehouse)
        {
            if (idWarehouse == null)
            {
                return new List<SelectListViewModel>();
            }

            var warehouse = await this.warehouseManager.GetByIdAsync(idWarehouse.Value);

            if (warehouse == null)
            {
                return new List<SelectListViewModel>();
            }
            var products = await this.productManager.GetAllAsync();
            var productsJoin = warehouse.Details.Where(d => d.Quantity > 0).Select(d => new { d.IdProduct, d.Quantity })
                .Join(products, d => d.IdProduct, d => d.Id, (warehouseProduct, product) => new { product, warehouseProduct.Quantity });

            return new List<SelectListViewModel>() {
                new SelectListViewModel
                {
                    Value = Resources.Models.Accounting.Warehouse.WarehouseMovementDetail.ProductSelected
                }
            }
            .Union(productsJoin.Select(b => new SelectListViewModel
            {
                Id = b.product.Id,
                Value = b.product.Name + " (" + b.Quantity + ")",
            }));
        }
    }
}

Contabilidad/Contabilidad.Site/Views/Warehouse/Create.cshtml
@model Contabilidad.Site.Models.Warehouse.WarehouseCreateViewModel
@{
    ViewData["Title"] = @Contabilidad.Resources.CommonResources.Create;
}
<div class="row clearfix">
    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
        <div class="x_panel">
            <div class="x_title">
                <h2>@Contabilidad.Resources.CommonResources.Create @Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.modelName</h2>
                <div class="clearfix"></div>
            </div>
            <div class="x_content">
                <form method="post" enctype="multipart/form-data">
                    @if (ViewData.ModelState[string.Empty]?.Errors?.Any() == true)
                    {
                        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                            <div class="card">
                                <div class="body bg-red">
                                    <div asp-validation-summary="ModelOnly"></div>
                                </div>
                            </div>
                        </div>
                    }

                    <label asp-for="IsActive">@Html.DisplayNameFor(Model => Model.IsActive)</label>
                    <div class="form-group">
                        <div class="form-line">
                            <div class="">
                                <input type="checkbox" class="icheckbox_flat-green checked" asp-for="IsActive" />
                            </div>
                        </div>
                        <ul class="parsley-errors-list filled">
                            <li>
                                <span asp-validation-for="IsActive"></span>
                            </li>
                        </ul>
                    </div>

                    <label asp-for="Description">@Html.DisplayNameFor(Model => Model.Code)</label>
                    <div class="form-group">
                        <div class="form-line">
                            <input asp-for="Code" class="form-control" />
                        </div>
                        <ul class="parsley-errors-list filled" id="parsley-id-5">
                            <li>
                                <span asp-validation-for="Code"></span>
                            </li>
                        </ul>
                    </div>

                    <label asp-for="Description">@Html.DisplayNameFor(Model => Model.Description)</label>
                    <div class="form-group">
                        <div class="form-line">
                            <input asp-for="Description" class="form-control" />
                        </div>
                        <ul class="parsley-errors-list filled" id="parsley-id-5">
                            <li>
                                <span asp-validation-for="Description"></span>
                            </li>
                        </ul>
                    </div>

                    <div align="right">
                        <a href="#confirm" class="btn btn-primary waves-effect" data-toggle="modal" data-target="#confirm">@Contabilidad.Resources.CommonResources.SaveChanges</a>
                    </div>
                    <div class="modal fade" id="confirm" tabindex="-1" role="dialog">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h4 class="modal-title" id="defaultModalLabel">@Contabilidad.Resources.CommonResources.Create @Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.modelName</h4>
                                </div>
                                <div class="modal-body">
                                    @Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.CreateMessage
                                </div>
                                <div class="modal-footer">
                                    <input type="submit" id="submitbutton" value="@Contabilidad.Resources.CommonResources.SaveChanges" data-disableonclick="true" class="btn btn-primary waves-effect" />
                                    <button type="button" class="btn btn-default waves-effect" data-dismiss="modal">@Contabilidad.Resources.CommonResources.Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

Contabilidad/Contabilidad.Site/Views/Warehouse/Details.cshtml
@model Contabilidad.Site.Models.Warehouse.WarehouseDetailsViewModel
@{
    ViewData["Title"] = @Contabilidad.Resources.CommonResources.Details;
}

<div class="row clearfix">
    <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
        <div class="x_panel">
            <div class="x_title">
                <h2>
                    @Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.DetailsTitle
                </h2>
                <div class="clearfix"></div>
            </div>
            <div class="x_content">
                <div>
                    <dl class="dl-horizontal">
                        <dt>
                            @Html.DisplayNameFor(model => model.IsActive)
                        </dt>
                        <dd>
                            @Html.DisplayFor(model => model.IsActive)
                        </dd>
                        <dt>
                            @Html.DisplayNameFor(model => model.Code)
                        </dt>
                        <dd>
                            @Html.DisplayFor(model => model.Code)
                        </dd>
                        <dt>
                            @Html.DisplayNameFor(model => model.Description)
                        </dt>
                        <dd>
                            @Html.DisplayFor(model => model.Description)
                        </dd>
                    </dl>
                </div>

                <br />
                <div class="row clearfix">
                    <div class="col-xs-6 col-sm-3 col-md-2 col-lg-2">
                        <a href="#confirm_@Model.Id" data-loader="true" class="btn btn-primary"
                           data-toggle="modal" data-target="#confirm_@Model.Id">@Contabilidad.Resources.CommonResources.Delete</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="row clearfix">
    <div class="x_panel">
        <div class="x_title">
            <h2>@Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.Stocks</h2>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <div class="row">
                <div class="col-sm-12">
                    <div class="card-box table-responsive">
                        <div class="row clearfix">
                            <div class="col-xs-6 col-sm-3 col-md-2 col-lg-2">
                                <a asp-action="MovementToWareohuses" asp-controller="WarehouseMovement" asp-route-idWarehouse="@Model.Id" data-loader="true" class="btn btn-primary">@Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.MovementWarehouses @Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.modelName</a>
                            </div>
                        </div>
                        <div id="datatable_wrapper" class="dataTables_wrapper container-fluid dt-bootstrap no-footer">
                            <div class="row">
                            </div>
                            <div class="row">
                                <div class="col-sm-12">
                                    <table id="datatable" class="table table-striped table-bordered dataTable no-footer" style="width: 100%;" role="grid" aria-describedby="datatable_info">
                                        <thead>
                                            <tr class="headings">
                                                <th>@Html.DisplayNameFor(Model => Model.Stocks.FirstOrDefault().Product)</th>
                                                <th>@Html.DisplayNameFor(Model => Model.Stocks.FirstOrDefault().Quantity)</th>
                                                <th>@Html.DisplayNameFor(Model => Model.Stocks.FirstOrDefault().MeasurementUnit)</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @foreach (var item in Model.Stocks)
                                            {
                                                <tr>
                                                    <td>
                                                        @Html.DisplayFor(modelItem => item.Product)
                                                    </td>
                                                    <td>
                                                        @Html.DisplayFor(modelItem => item.Quantity)
                                                    </td>
                                                    <td>
                                                        @Html.DisplayFor(modelItem => item.MeasurementUnit)
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


<form asp-action="Delete" asp-route-id="@Model.Id">
    <div class="modal fade" id="confirm_@Model.Id" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="defaultModalLabel">@Contabilidad.Resources.CommonResources.Delete @Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.modelName</h4>
                </div>
                <div class="modal-body">
                    @Contabilidad.Resources.Models.Accounting.Warehouse.Warehouse.MessageDelete
                </div>
                <div class="modal-footer">
                    <input type="submit" value="@Contabilidad.Resources.CommonResources.Delete" data-loader="true" class="btn btn-danger waves-effect" />
                    <button type="button" class="btn btn-default waves-effect" data-dismiss="modal">@Contabilidad.Resources.CommonResources.Cancel</button>
                </div>
            </div>
        </div>
    </div>
</form>